#include <stdio.h>
#include <sqlite.h>

int callback(void *pArg, int argc, char **argv, char **columnNames)
{
  int i;
  for (i=0; i<argc; i++) {
    printf("%-10s %-8s %s\n",
                columnNames[i], columnNames[i+argc], argv[i]);
  }
  return(0);
}


main()
{

  char *errmsg;
  int ret;

  sqlite *db = sqlite_open("progdb", 0777, &errmsg);

  if (db == 0)
  {
    fprintf(stderr, "Could not open database: %s\n", errmsg);
    sqlite_freemem(errmsg);
    exit(1);
  }

  ret = sqlite_exec(db, "PRAGMA SHOW_DATATYPES=ON", NULL, NULL, NULL);

  ret = sqlite_exec(db, "SELECT * FROM contacts", callback, NULL, &errmsg);

  if (ret != SQLITE_OK)
  {
    fprintf(stderr, "SQL error: %s\n", errmsg);
  }

  sqlite_close(db);
}
