#include <stdio.h>
#include <sqlite.h>


void capitalize_alternate(sqlite_func *context, int argc, const char **argv)
{
  int i;
  static char str[80];

  for (i=0; i<strlen(argv[0]); i++) {
    if (i%2 == 0)
      str[i] = toupper(argv[0][i]);
    else
      str[i] = tolower(argv[0][i]);
  }
  str[i] = '\0';

  sqlite_set_result_string(context, str, -1);
}

main()
{

  char *errmsg;
  char **result;
  char str[80];
  int ret, rows, cols, i, j;

  sqlite *db = sqlite_open("progdb", 0777, &errmsg);

  if (db == 0)
  {
    fprintf(stderr, "Could not open database: %s\n", errmsg);
    sqlite_freemem(errmsg);
    exit(1);
  }

  sqlite_create_function(db, "altcaps", 1, capitalize_alternate, NULL);

  ret = sqlite_get_table(db, "SELECT altcaps('this is a test')",
                                              &result, &rows, &cols, &errmsg); 

  if (ret != SQLITE_OK)
  {
    fprintf(stderr, "SQL error: %s\n", errmsg);
  }
  else {
    for (i=0; i< cols * (rows+1); i++) {
      printf("result[%d] = %s\n", i, result[i]);
    }
  }

  sqlite_close(db);
}
