#!/usr/bin/perl

package median;

sub new {
  my $classtype = shift;
  bless [], $classtype;
}

sub step {
  my ( $context, $value ) = @_;
  push @context, $value;
}

sub finalize {

  my $context = $_[0];

  if (!@context) {
    return undef;
  }

  @sorted = sort { $a <=> $b } @context;
  $count = @sorted;

  if ($count%2 == 1) { # Odd number of elements
    $median = $sorted[int($count/2)];
  }
  else {               # Even number of elements
    $median = ($sorted[$count/2] + $sorted[($count/2)-1] ) / 2;
  }

  return $median;
}

use DBI;

$dbh = DBI->connect("DBI:SQLite:dbname=perldb", "", "")
       or die("Cannot connect: " . $dbh->errstr() );

$dbh->func( "median", 1, "median", "create_aggregate" );

$sql = "SELECT median(num), AVG(num) FROM numbers";

$sth = $dbh->prepare($sql)
       or die("Cannot prepare: " . $dbh->errstr() );

$sth->execute() or die("Cannot execute: ". $dbh->errstr() );

my ($median, $mean) = $sth->fetchrow_array();
print "Median: $median \n";
print "Mean: $mean \n";
