#include <stdio.h>
#include <sqlite.h>

main()
{

  char *errmsg;
  int ret;

  sqlite *db = sqlite_open("db1", 0777, &errmsg);

  if (db == 0)
  {
    fprintf(stderr, "Could not open database: %s\n", errmsg);
    sqlite_freemem(errmsg);
    exit(1);
  }

  do {
    ret = sqlite_exec(db, "INSERT INTO mytable (col1, col2) VALUES (1, 2)",
                      NULL, NULL, &errmsg);

    switch(ret) {

       case SQLITE_OK:    break;

       case SQLITE_BUSY:  fprintf(stderr, "Database locked, sleeping...\n");
                          sleep(1);
                          break;

       default:           fprintf(stderr, "Error: %s\n", errmsg);
                          sqlite_freemem(errmsg);
                          exit(ret);

    }

  } while (ret != SQLITE_OK);

  sqlite_close(db);
}
