#include <stdio.h>
#include <sqlite.h>

static int myhandler(void *NotUsed, const char *dbname, int numtries) {
  fprintf(stderr, "Database locked on try %d, sleeping...\n", numtries);
  if (numtries >= 5)
    return(0);
  else {
    sleep(1);
    return(1);
  }
}

main()
{

  char *errmsg;
  int ret;

  sqlite *db = sqlite_open("db1", 0777, &errmsg);

  if (db == 0)
  {
    fprintf(stderr, "Could not open database: %s\n", errmsg);
    sqlite_freemem(errmsg);
    exit(1);
  }

  sqlite_busy_handler(db, myhandler, NULL);

  ret = sqlite_exec(db, "INSERT INTO mytable (col1, col2) VALUES (1, 2)",
                    NULL, NULL, &errmsg);

  if (ret != SQLITE_OK) {
    fprintf(stderr, "Error: %s\n", errmsg);
    sqlite_freemem(errmsg);
    exit(ret);
  }

  sqlite_close(db);
}
